blob: d3c7f943e7ebac8fee72e9bee8f177f875f72edc [file] [log] [blame]
Patrick Williamsc124f4f2015-09-15 14:41:29 -05001#!/bin/sh
2
3# OE Build Environment Setup Script
4#
5# Copyright (C) 2006-2011 Linux Foundation
6#
Brad Bishopc342db32019-05-15 21:57:59 -04007# SPDX-License-Identifier: GPL-2.0-or-later
Patrick Williamsc124f4f2015-09-15 14:41:29 -05008#
Patrick Williamsc124f4f2015-09-15 14:41:29 -05009
10if [ -z "$BUILDDIR" ]; then
11 echo >&2 "Error: The build directory (BUILDDIR) must be set!"
12 exit 1
13fi
14
Brad Bishop6e60e8b2018-02-01 10:27:11 -050015if [ "$1" = '--help' -o "$1" = '-h' ]; then
16 echo 'Usage: oe-setup-builddir'
17 echo ''
18 echo "OpenEmbedded setup-builddir - setup build directory $BUILDDIR"
19 echo ''
20 exit 2
21fi
22
Patrick Williamsc124f4f2015-09-15 14:41:29 -050023mkdir -p "$BUILDDIR/conf"
24
25if [ ! -d "$BUILDDIR" ]; then
26 echo >&2 "Error: The builddir ($BUILDDIR) does not exist!"
27 exit 1
28fi
29
30if [ ! -w "$BUILDDIR" ]; then
31 echo >&2 "Error: Cannot write to $BUILDDIR, perhaps try sourcing with a writable path? i.e. . oe-init-build-env ~/my-build"
32 exit 1
33fi
34
35# Attempting removal of sticky,setuid bits from BUILDDIR, BUILDDIR/conf
36chmod -st "$BUILDDIR" 2>/dev/null || echo "WARNING: unable to chmod $BUILDDIR"
37chmod -st "$BUILDDIR/conf" 2>/dev/null || echo "WARNING: unable to chmod $BUILDDIR/conf"
38
39cd "$BUILDDIR"
40
Patrick Williams92b42cb2022-09-03 06:53:57 -050041if [ -f "$BUILDDIR/conf/templateconf.cfg" -a -z "$TEMPLATECONF" ]; then
Patrick Williamsc124f4f2015-09-15 14:41:29 -050042 TEMPLATECONF=$(cat "$BUILDDIR/conf/templateconf.cfg")
Patrick Williams92b42cb2022-09-03 06:53:57 -050043 # The following two are no longer valid; unsetting them will automatically get them replaced
44 # with correct ones.
45 if [ $TEMPLATECONF = "meta/conf" -o $TEMPLATECONF = "meta-poky/conf" ]; then
46 unset TEMPLATECONF
47 rm $BUILDDIR/conf/templateconf.cfg
48 fi
Patrick Williamsc124f4f2015-09-15 14:41:29 -050049fi
50
Patrick Williamsde0582f2022-04-08 10:23:27 -050051. "$OEROOT"/.templateconf
Patrick Williamsc124f4f2015-09-15 14:41:29 -050052
Patrick Williamsc124f4f2015-09-15 14:41:29 -050053#
54# $TEMPLATECONF can point to a directory for the template local.conf & bblayers.conf
55#
56if [ -n "$TEMPLATECONF" ]; then
57 if [ ! -d "$TEMPLATECONF" ]; then
58 # Allow TEMPLATECONF=meta-xyz/conf as a shortcut
59 if [ -d "$OEROOT/$TEMPLATECONF" ]; then
60 TEMPLATECONF="$OEROOT/$TEMPLATECONF"
61 fi
62 if [ ! -d "$TEMPLATECONF" ]; then
Brad Bishop37a0e4d2017-12-04 01:01:44 -050063 echo >&2 "Error: TEMPLATECONF value points to nonexistent directory '$TEMPLATECONF'"
Patrick Williamsc124f4f2015-09-15 14:41:29 -050064 exit 1
65 fi
Patrick Williams92b42cb2022-09-03 06:53:57 -050066 templatesdir=$(python3 -c "import sys; print(sys.argv[1].strip('/').split('/')[-2])" $TEMPLATECONF)
67 if [ ! -f "$TEMPLATECONF/../../layer.conf" -o $templatesdir != "templates" ]; then
68 echo >&2 "Error: TEMPLATECONF value (which is $TEMPLATECONF) must point to meta-some-layer/conf/templates/template-name"
69 exit 1
70 fi
Patrick Williamsc124f4f2015-09-15 14:41:29 -050071 fi
72 OECORELAYERCONF="$TEMPLATECONF/bblayers.conf.sample"
73 OECORELOCALCONF="$TEMPLATECONF/local.conf.sample"
74 OECORENOTESCONF="$TEMPLATECONF/conf-notes.txt"
75fi
76
77unset SHOWYPDOC
78if [ -z "$OECORELOCALCONF" ]; then
79 OECORELOCALCONF="$OEROOT/meta/conf/local.conf.sample"
80fi
81if [ ! -r "$BUILDDIR/conf/local.conf" ]; then
Patrick Williamsd8c66bc2016-06-20 12:57:21 -050082 cat <<EOM
Patrick Williamsc124f4f2015-09-15 14:41:29 -050083You had no conf/local.conf file. This configuration file has therefore been
Patrick Williamsdb4c27e2022-08-05 08:10:29 -050084created for you from $OECORELOCALCONF
85You may wish to edit it to, for example, select a different MACHINE (target
86hardware). See conf/local.conf for more information as common configuration
87options are commented.
Patrick Williamsc124f4f2015-09-15 14:41:29 -050088
89EOM
Patrick Williamsde0582f2022-04-08 10:23:27 -050090 cp -f "$OECORELOCALCONF" "$BUILDDIR/conf/local.conf"
Patrick Williamsc124f4f2015-09-15 14:41:29 -050091 SHOWYPDOC=yes
92fi
93
94if [ -z "$OECORELAYERCONF" ]; then
95 OECORELAYERCONF="$OEROOT/meta/conf/bblayers.conf.sample"
96fi
97if [ ! -r "$BUILDDIR/conf/bblayers.conf" ]; then
98 cat <<EOM
Patrick Williamsd8c66bc2016-06-20 12:57:21 -050099You had no conf/bblayers.conf file. This configuration file has therefore been
Patrick Williamsdb4c27e2022-08-05 08:10:29 -0500100created for you from $OECORELAYERCONF
101To add additional metadata layers into your configuration please add entries
102to conf/bblayers.conf.
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500103
104EOM
105
Andrew Geissler9aee5002022-03-30 16:27:02 +0000106 # Put the absolute path to the layers in bblayers.conf so we can run
107 # bitbake without the init script after the first run.
108 # ##COREBASE## is deprecated as its meaning was inconsistent, but continue
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500109 # to replace it for compatibility.
110 sed -e "s|##OEROOT##|$OEROOT|g" \
111 -e "s|##COREBASE##|$OEROOT|g" \
Patrick Williamsde0582f2022-04-08 10:23:27 -0500112 "$OECORELAYERCONF" > "$BUILDDIR/conf/bblayers.conf"
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500113 SHOWYPDOC=yes
114fi
115
116# Prevent disturbing a new GIT clone in same console
117unset OECORELOCALCONF
118unset OECORELAYERCONF
119
120# Ending the first-time run message. Show the YP Documentation banner.
121if [ ! -z "$SHOWYPDOC" ]; then
122 cat <<EOM
123The Yocto Project has extensive documentation about OE including a reference
124manual which can be found at:
Patrick Williams213cb262021-08-07 19:21:33 -0500125 https://docs.yoctoproject.org
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500126
Andrew Geissler9aee5002022-03-30 16:27:02 +0000127For more information about OpenEmbedded see the website:
Patrick Williams213cb262021-08-07 19:21:33 -0500128 https://www.openembedded.org/
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500129
130EOM
131# unset SHOWYPDOC
132fi
133
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500134if [ -z "$OECORENOTESCONF" ]; then
135 OECORENOTESCONF="$OEROOT/meta/conf/conf-notes.txt"
136fi
Patrick Williamsde0582f2022-04-08 10:23:27 -0500137[ ! -r "$OECORENOTESCONF" ] || cat "$OECORENOTESCONF"
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500138unset OECORENOTESCONF
Patrick Williams92b42cb2022-09-03 06:53:57 -0500139
140if [ ! -f "$BUILDDIR/conf/templateconf.cfg" ]; then
141 echo "$TEMPLATECONF" >"$BUILDDIR/conf/templateconf.cfg"
142fi